## kf6-breeze-icons 6.23.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.27)

set(KF_VERSION "6.23.0") # handled by release scripts
project(BreezeIcons VERSION ${KF_VERSION})

# Disallow in-source build
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
   message(FATAL_ERROR "Breeze Icons requires an out-of-source build. Please create a separate build directory and run 'cmake path_to_breeze_icons [options]' there.")
endif()

# ECM setup
include(FeatureSummary)
find_package(ECM 6.23.0  NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(ECMSetupVersion)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEGitCommitHooks)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(GtkUpdateIconCache)
include(ECMGenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMSetupVersion)

# Dependencies
set(REQUIRED_QT_VERSION 6.8.0)
find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED COMPONENTS Core Gui)

# Find Python 3
find_package(Python 3 COMPONENTS Interpreter)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# We need this for KDE-BUG 499674. qt_add_resources has issues with 32-bit
# systems, while qt_add_big_resources has issues with LTO. We use qt_add_big_resources
# and disable LTO.
check_cxx_compiler_flag(-fno-lto COMPILER_SUPPORTS_NO_LTO)
check_cxx_compiler_flag(/GL- COMPILER_SUPPORTS_NO_GL)
if(COMPILER_SUPPORTS_NO_LTO)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lto")
elseif(COMPILER_SUPPORTS_NO_GL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GL-")
endif()
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION OFF)

# 24x24 generation (requires python)
option(WITH_ICON_GENERATION "24x24 icon generation" ON)
add_feature_info("Icon generation" ${WITH_ICON_GENERATION} "for 24x24 icons, this feature requires Python 3 and the lxml Python 3 module.")
if(WITH_ICON_GENERATION)
    find_package(Python 3 COMPONENTS Interpreter REQUIRED)
endif()

# don't install the individual icons
# useful if you only want to link with the generated icon library
option(SKIP_INSTALL_ICONS "Skip installing the icons files" OFF)

# pure compatibility option for e.g. Kexi, not used in general and wastes disk space
# FIXME: remove after e.g. Kexi is ported
option(BINARY_ICONS_RESOURCE "Install Qt binary resource file containing breeze icons (breeze-icons.rcc), should only be used if needed for compatibility" OFF)

option(WITH_ICONS_LIBRARY "Build the Breeze icons library" ON)

if(WITH_ICONS_LIBRARY)
    set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF6BreezeIcons")

    configure_package_config_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/KF6BreezeIconsConfig.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/KF6BreezeIconsConfig.cmake"
      INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
      PATH_VARS  CMAKE_INSTALL_PREFIX
    )

    install(FILES
      "${CMAKE_CURRENT_BINARY_DIR}/KF6BreezeIconsConfig.cmake"
      "${CMAKE_CURRENT_BINARY_DIR}/KF6BreezeIconsConfigVersion.cmake"
      DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
      COMPONENT Devel
    )

    ecm_setup_version(PROJECT
      VARIABLE_PREFIX BREEZEICONS
      VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/breezeicons_version.h
      PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF6BreezeIconsConfigVersion.cmake"
      SOVERSION 6)

    install(EXPORT KF6BreezeIconsTargets
      DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
      FILE KF6BreezeIconsTargets.cmake
      NAMESPACE KF6::
    )

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/breezeicons_version.h
      DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/BreezeIcons COMPONENT Devel)
endif()

# tools to generate icons and resources
add_subdirectory(tools)

# generate and install both variants
add_subdirectory(icons)

# unit tests
add_subdirectory(autotests)

include(ECMFeatureSummary)
ecm_feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES INCLUDE_QUIET_PACKAGES)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== icons/CMakeLists.txt ===
# avoid dependency cycle with add resource
set(CMAKE_AUTOMOC OFF)

# declare both install dirs, icons will install fallback icons to dark, too!
set(BREEZE_INSTALL_DIR ${KDE_INSTALL_FULL_ICONDIR}/breeze)
set(BREEZE_DARK_INSTALL_DIR ${KDE_INSTALL_FULL_ICONDIR}/breeze-dark)

# generate resource file for all breeze icons
set(RESOURCE_FILE ${CMAKE_CURRENT_BINARY_DIR}/breeze-icons.qrc)
set(RESOURCE_FILE_BINARY ${CMAKE_CURRENT_BINARY_DIR}/breeze-icons.rcc)

# set and create the generation directories, we always need them
set(ICON_GEN_DIR ${CMAKE_BINARY_DIR}/breeze/icons)
set(ICON_DARK_GEN_DIR ${CMAKE_BINARY_DIR}/breeze/icons-dark)
file(MAKE_DIRECTORY ${ICON_GEN_DIR})
file(MAKE_DIRECTORY ${ICON_DARK_GEN_DIR})

# get all icon categories
FILE(GLOB possible_icon_dirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*)
SET(breeze_icon_dirs "")
FOREACH(possible_icon_dir ${possible_icon_dirs})
    IF(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${possible_icon_dir})
        LIST(APPEND breeze_icon_dirs ${possible_icon_dir})
    ENDIF()
ENDFOREACH()

# get all icons as dependencies for the generation
file(GLOB_RECURSE icon_svgs ${CMAKE_CURRENT_SOURCE_DIR}/*.svg)

# generate the two theme indices
file(COPY_FILE breeze.theme.in ${ICON_GEN_DIR}/index.theme)
file(READ commonthemeinfo.theme.in COMMON_THEME_INFO)
file(APPEND ${ICON_GEN_DIR}/index.theme ${COMMON_THEME_INFO})
file(COPY_FILE breeze-dark.theme.in ${ICON_DARK_GEN_DIR}/index.theme)
file(READ commonthemeinfo.theme.in COMMON_THEME_INFO)
file(APPEND ${ICON_DARK_GEN_DIR}/index.theme ${COMMON_THEME_INFO})

# generate stuff if wanted
if(WITH_ICON_GENERATION)
    # generate 24px & dark icons + do checking and create the resource
    add_custom_command(OUTPUT ${RESOURCE_FILE}
        COMMENT "Generating 24px & symbolic dark icons and resources"
        COMMAND ${Python_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/generate-24px-versions.py ${CMAKE_CURRENT_SOURCE_DIR} ${ICON_GEN_DIR}
        COMMAND $<TARGET_FILE:generate-symbolic-dark> ${CMAKE_SOURCE_DIR}/icons ${ICON_GEN_DIR} ${ICON_DARK_GEN_DIR}
        COMMAND $<TARGET_FILE:qrcAlias> -o ${RESOURCE_FILE} ${CMAKE_SOURCE_DIR}/icons ${ICON_GEN_DIR} # used for the resource
        COMMAND $<TARGET_FILE:qrcAlias> -o ${RESOURCE_FILE}.dark.dummy ${CMAKE_SOURCE_DIR}/icons ${ICON_GEN_DIR} ${ICON_DARK_GEN_DIR} # used for checking only
        COMMAND Qt6::rcc --binary -o ${RESOURCE_FILE_BINARY} ${RESOURCE_FILE} # FIXME: remove after e.g. Kexi is ported
        DEPENDS ${icon_svgs} commonthemeinfo.theme.in breeze.theme.in breeze-dark.theme.in
        USES_TERMINAL
    )
else()
    # generate dark icons + do checking and create the resource
    add_custom_command(OUTPUT ${RESOURCE_FILE}
        COMMENT "Generating symbolic dark icons and resources"
        COMMAND $<TARGET_FILE:generate-symbolic-dark> ${CMAKE_SOURCE_DIR}/icons ${ICON_GEN_DIR} ${ICON_DARK_GEN_DIR}
        COMMAND $<TARGET_FILE:qrcAlias> -o ${RESOURCE_FILE} ${CMAKE_SOURCE_DIR}/icons ${ICON_GEN_DIR} # used for the resource
        COMMAND $<TARGET_FILE:qrcAlias> -o ${RESOURCE_FILE}.dark.dummy ${CMAKE_SOURCE_DIR}/icons ${ICON_GEN_DIR} ${ICON_DARK_GEN_DIR} # used for checking only
        COMMAND Qt6::rcc --binary -o ${RESOURCE_FILE_BINARY} ${RESOURCE_FILE} # FIXME: remove after e.g. Kexi is ported
        DEPENDS ${icon_svgs} commonthemeinfo.theme.in breeze.theme.in breeze-dark.theme.in
        USES_TERMINAL
    )
endif()

# install as compatibility resource file if really requested
# FIXME: remove after e.g. Kexi is ported
if(BINARY_ICONS_RESOURCE)
    install(FILES ${RESOURCE_FILE_BINARY} DESTINATION ${BREEZE_INSTALL_DIR})
endif()

if(NOT SKIP_INSTALL_ICONS)
    # install the instantiated theme indices
    install(FILES ${ICON_GEN_DIR}/index.theme DESTINATION ${BREEZE_INSTALL_DIR})
    install(FILES ${ICON_DARK_GEN_DIR}/index.theme DESTINATION ${BREEZE_DARK_INSTALL_DIR})

    # we install icons as breeze and as fallback for breeze-dark
    # breeze-dark will overwrite some installed files with generated color patched ones

    install(DIRECTORY ${breeze_icon_dirs} DESTINATION ${BREEZE_INSTALL_DIR})
    install(DIRECTORY ${breeze_icon_dirs} DESTINATION ${BREEZE_DARK_INSTALL_DIR})

    if(WITH_ICON_GENERATION)
        install(DIRECTORY ${ICON_GEN_DIR}/ DESTINATION ${BREEZE_INSTALL_DIR})
        install(DIRECTORY ${ICON_GEN_DIR}/ DESTINATION ${BREEZE_DARK_INSTALL_DIR})
    endif()

    # generated dark icons are installed on-top
    install(DIRECTORY ${ICON_DARK_GEN_DIR}/ DESTINATION ${BREEZE_DARK_INSTALL_DIR})

    # update the icon caches
    gtk_update_icon_cache(${BREEZE_INSTALL_DIR})
    gtk_update_icon_cache(${BREEZE_DARK_INSTALL_DIR})
endif()

if (WITH_ICONS_LIBRARY)
    # helper functions to ensure we load the icon theme
    set(kbreezeicons_SRCS breezeicons.cpp)

    # use big resource variant, else we OOM on 32 bit machines
    # this has issues with LTO, we have a unit test that tells if stuff got lost in the DLL
    qt_add_big_resources(kbreezeicons_resource_SRCS
        ${RESOURCE_FILE}
        OPTIONS --root /icons/breeze
    )


    add_library(KF6BreezeIcons ${kbreezeicons_resource_SRCS} ${kbreezeicons_SRCS})
    add_library(KF6::BreezeIcons ALIAS KF6BreezeIcons)

    set_target_properties(KF6BreezeIcons
        PROPERTIES
            VERSION ${BREEZEICONS_VERSION}
            SOVERSION ${BREEZEICONS_SOVERSION}
            EXPORT_NAME BreezeIcons
    )

    generate_export_header(KF6BreezeIcons BASE_NAME BreezeIcons)

    target_include_directories(KF6BreezeIcons
        INTERFACE
            "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/BreezeIcons>"
    )

    target_link_libraries(KF6BreezeIcons
        PUBLIC
            Qt6::Gui
    )

    ecm_generate_headers(KF6BreezeIcons_CamelCase_HEADERS
        HEADER_NAMES
            BreezeIcons

        REQUIRED_HEADERS
            KF6BreezeIcons_HEADERS
    )

    install(TARGETS KF6BreezeIcons EXPORT KF6BreezeIconsTargets ${KF_INSTALL_TARGETS_DEFAULT_ARGS})

    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/breezeicons_export.h
        ${KF6BreezeIcons_HEADERS}
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/BreezeIcons
        COMPONENT Devel
    )

    install(FILES
        ${KF6BreezeIcons_CamelCase_HEADERS}
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/BreezeIcons
        COMPONENT Devel
    )

endif()

=== tools/CMakeLists.txt ===
include(ECMMarkNonGuiExecutable)

if (CMAKE_CROSSCOMPILING AND KF6_HOST_TOOLING)
    find_program(GENERATE_SYMBOLIC_DARK generate-symbolic-dark PATHS ${KF6_HOST_TOOLING} NO_CACHE NO_CMAKE_FIND_ROOT_PATH)
    find_program(QRC_ALIAS qrcAlias PATHS ${KF6_HOST_TOOLING} NO_CACHE NO_CMAKE_FIND_ROOT_PATH)
    if (GENERATE_SYMBOLIC_DARK)
        add_executable(generate-symbolic-dark IMPORTED GLOBAL)
        set_target_properties(generate-symbolic-dark PROPERTIES IMPORTED_LOCATION
                              ${GENERATE_SYMBOLIC_DARK})
        message (STATUS "Using generate-symbolic-dark from '${GENERATE_SYMBOLIC_DARK}'")
    else ()
        message (WARNING "Could not find generate-symbolic-dark in '${KF6_HOST_TOOLING}'.")
    endif ()

    if (QRC_ALIAS)
        add_executable(qrcAlias IMPORTED GLOBAL)
        set_target_properties(qrcAlias PROPERTIES IMPORTED_LOCATION
                              ${QRC_ALIAS})
        message (STATUS "Using qrcAlias from '${QRC_ALIAS}'")
    else ()
        message (WARNING "Could not find qrcAlias in '${KF6_HOST_TOOLING}'.")
    endif ()
else ()
    # takes light theme icons and makes modified copies of them with dark theme stylesheets
    add_executable(generate-symbolic-dark generate-symbolic-dark.cpp)
    target_link_libraries(generate-symbolic-dark PRIVATE Qt6::Core)
    ecm_mark_nongui_executable(generate-symbolic-dark)
    if (INSTALL_HOST_TOOLS)
        install(TARGETS generate-symbolic-dark ${KF_INSTALL_TARGETS_DEFAULT_ARGS})
    endif()


    # qrc generator
    add_executable(qrcAlias qrcAlias.cpp)
    target_link_libraries(qrcAlias PRIVATE Qt6::Core)
    ecm_mark_nongui_executable(qrcAlias)
    if (INSTALL_HOST_TOOLS)
        install(TARGETS qrcAlias ${KF_INSTALL_TARGETS_DEFAULT_ARGS})
    endif()
endif ()

=== debian/changelog ===
kf6-breeze-icons (6.23.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (6.23.0).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.7.3, no change required.
  * Drop Rules-Requires-Root: no, not needed anymore since trixie.
  * Drop Priority: optional, not needed anymore since dpkg 1.22.13.
  * Add/update Nicolas Fella’s key in upstream keyring.
  * Use DEB_HOST_MULTIARCH in libraries install path.
  * Refresh copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 21 Feb 2026 16:47:45 +0100

=== debian/control ===
Source: kf6-breeze-icons
Section: libs
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.27~),
               extra-cmake-modules (>= 6.23.0~),
               libxkbcommon-dev,
               pkgconf,
               qt6-base-dev (>= 6.8.0~),
Build-Depends-Indep: fdupes,
                     libxml2-utils,
                     python3-lxml,
Standards-Version: 4.7.3
Homepage: https://invent.kde.org/frameworks/breeze-icons
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-breeze-icons
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-breeze-icons.git

Package: kf6-breeze-icon-theme
Section: kde
Architecture: all
Multi-Arch: foreign
Depends: hicolor-icon-theme,
         ${misc:Depends},
Breaks: breeze-icon-theme (<< 4:5.115.0-3~),
Replaces: breeze-icon-theme (<< 4:5.115.0-3~),
Description: Default Plasma icon theme
 This is the default icon theme for the KDE Plasma 6 desktop.
 .
 This package is part of the Breeze theme module.

Package: kf6-breeze-icon-theme-rcc
Section: kde
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Breaks: breeze-icon-theme-rcc (<< 4:5.115.0-3~),
Replaces: breeze-icon-theme-rcc (<< 4:5.115.0-3~),
Description: RCC resources for the breeze icon theme
 Breeze is the default icon theme for the KDE Plasma 6 desktop. This package
 contains the icons in RCC format.
 .
 This package is part of the Breeze theme module.

Package: libkf6breezeicons-dev
Section: libdevel
Architecture: any
Depends: kf6-breeze-icon-theme-rcc,
         libkf6breezeicons6 (= ${binary:Version}),
         qt6-base-dev (>= 6.8.0~),
         ${misc:Depends},
Description: Default Plasma icon theme (development files)
 This is the default icon theme for the KDE Plasma 6 desktop.
 .
 This package is part of the Breeze theme module.
 .
 This package contains the development files.

Package: libkf6breezeicons6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Default Plasma icon theme
 This is the default icon theme for the KDE Plasma 6 desktop.
 .
 This package is part of the Breeze theme module.
